/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.core.marker.volume;

import net.minecraft.client.renderer.BufferBuilder;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.math.AxisAlignedBB;

import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

@SideOnly(Side.CLIENT)
public class AddonDefaultRenderer<T extends Addon> implements IFastAddonRenderer<T> {
    private final TextureAtlasSprite s;

    public AddonDefaultRenderer() {
        s = ModelLoader.White.INSTANCE;
    }

    public AddonDefaultRenderer(TextureAtlasSprite s) {
        this.s = s;
    }

    @Override
    public void renderAddonFast(T addon, EntityPlayer player, float partialTicks, BufferBuilder builder) {
        AxisAlignedBB bb = addon.getBoundingBox();

        builder.func_181662_b(bb.field_72340_a, bb.field_72337_e, bb.field_72339_c).func_181669_b(204, 204, 204, 255).func_187315_a(s.func_94209_e(), s.func_94206_g()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72336_d, bb.field_72337_e, bb.field_72339_c).func_181669_b(204, 204, 204, 255).func_187315_a(s.func_94209_e(), s.func_94210_h()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72336_d, bb.field_72338_b, bb.field_72339_c).func_181669_b(204, 204, 204, 255).func_187315_a(s.func_94212_f(), s.func_94210_h()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72340_a, bb.field_72338_b, bb.field_72339_c).func_181669_b(204, 204, 204, 255).func_187315_a(s.func_94212_f(), s.func_94206_g()).func_187314_a(240, 0).func_181675_d();

        builder.func_181662_b(bb.field_72340_a, bb.field_72338_b, bb.field_72334_f).func_181669_b(204, 204, 204, 255).func_187315_a(s.func_94209_e(), s.func_94206_g()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72336_d, bb.field_72338_b, bb.field_72334_f).func_181669_b(204, 204, 204, 255).func_187315_a(s.func_94209_e(), s.func_94210_h()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72336_d, bb.field_72337_e, bb.field_72334_f).func_181669_b(204, 204, 204, 255).func_187315_a(s.func_94212_f(), s.func_94210_h()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72340_a, bb.field_72337_e, bb.field_72334_f).func_181669_b(204, 204, 204, 255).func_187315_a(s.func_94212_f(), s.func_94206_g()).func_187314_a(240, 0).func_181675_d();

        builder.func_181662_b(bb.field_72340_a, bb.field_72338_b, bb.field_72339_c).func_181669_b(127, 127, 127, 255).func_187315_a(s.func_94209_e(), s.func_94206_g()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72336_d, bb.field_72338_b, bb.field_72339_c).func_181669_b(127, 127, 127, 255).func_187315_a(s.func_94209_e(), s.func_94210_h()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72336_d, bb.field_72338_b, bb.field_72334_f).func_181669_b(127, 127, 127, 255).func_187315_a(s.func_94212_f(), s.func_94210_h()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72340_a, bb.field_72338_b, bb.field_72334_f).func_181669_b(127, 127, 127, 255).func_187315_a(s.func_94212_f(), s.func_94206_g()).func_187314_a(240, 0).func_181675_d();

        builder.func_181662_b(bb.field_72340_a, bb.field_72337_e, bb.field_72334_f).func_181669_b(255, 255, 255, 255).func_187315_a(s.func_94209_e(), s.func_94206_g()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72336_d, bb.field_72337_e, bb.field_72334_f).func_181669_b(255, 255, 255, 255).func_187315_a(s.func_94209_e(), s.func_94210_h()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72336_d, bb.field_72337_e, bb.field_72339_c).func_181669_b(255, 255, 255, 255).func_187315_a(s.func_94212_f(), s.func_94210_h()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72340_a, bb.field_72337_e, bb.field_72339_c).func_181669_b(255, 255, 255, 255).func_187315_a(s.func_94212_f(), s.func_94206_g()).func_187314_a(240, 0).func_181675_d();

        builder.func_181662_b(bb.field_72340_a, bb.field_72338_b, bb.field_72334_f).func_181669_b(153, 153, 153, 255).func_187315_a(s.func_94209_e(), s.func_94206_g()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72340_a, bb.field_72337_e, bb.field_72334_f).func_181669_b(153, 153, 153, 255).func_187315_a(s.func_94209_e(), s.func_94210_h()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72340_a, bb.field_72337_e, bb.field_72339_c).func_181669_b(153, 153, 153, 255).func_187315_a(s.func_94212_f(), s.func_94210_h()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72340_a, bb.field_72338_b, bb.field_72339_c).func_181669_b(153, 153, 153, 255).func_187315_a(s.func_94212_f(), s.func_94206_g()).func_187314_a(240, 0).func_181675_d();

        builder.func_181662_b(bb.field_72336_d, bb.field_72338_b, bb.field_72339_c).func_181669_b(153, 153, 153, 255).func_187315_a(s.func_94209_e(), s.func_94206_g()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72336_d, bb.field_72337_e, bb.field_72339_c).func_181669_b(153, 153, 153, 255).func_187315_a(s.func_94209_e(), s.func_94210_h()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72336_d, bb.field_72337_e, bb.field_72334_f).func_181669_b(153, 153, 153, 255).func_187315_a(s.func_94212_f(), s.func_94210_h()).func_187314_a(240, 0).func_181675_d();
        builder.func_181662_b(bb.field_72336_d, bb.field_72338_b, bb.field_72334_f).func_181669_b(153, 153, 153, 255).func_187315_a(s.func_94212_f(), s.func_94206_g()).func_187314_a(240, 0).func_181675_d();
    }
}
